/*
====================================================================================================
===========================================    Knife    ============================================
===========================================    Round    ============================================
===========================================     by      ============================================
===========================================    Juice	============================================
====================================================================================================

.: Description :.

1. When admin types /kf, /kr, or /kniferound, knife round begins
2. When knife round begins, your weapons will be auto switched to knife
3. After knife round end, in new round the winning team can choose: swap teams or not
4. You can choose no slash by cvar

.: Admin Commands :.

say /kf, /kr, /kniferound - start knife round
say /swap - swap teams
say /rr - restart round

.: Cvars :.

kr_teamvote - enable/disable vote after knife round
kr_noslash - enable/disable noslash in knife round

.: Credits :.
tolsty - helped me with vote: http://forums.alliedmods.net/showthread.php?t=103498
rhin0 - knife code from his "Simple ClanWar Management" http://forums.alliedmods.net/showthread.php?t=26726
Jon - swap teams code from his HnS plugin http://forums.alliedmods.net/showthread.php?t=73244

.: Changelog :.
1.0 - Knife code from "Simple ClanWar Management"
1.1 - Removed messages, added cur_weapon event instead of strip_weapons task
1.2 - Added vote, bug fixes
1.3 - Small fixes, another Swap Teams method
1.4 - Added multillingual :D
1.5 - Ham_Weapon_PrimaryAttack instead of FM_CmdStart for noslash
1.6 - Shield blocking, Ignoring c4 while KR, pl and nl translations
1.7 - Bug fixes
1.8 - Removed c4 ignore, small code optimization
1.9 - Hello Jon. :>
*/

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>
#include <colorchat>

#define PLUGIN "Knife Round"
#define VERSION "1.9"
#define AUTHOR "Juice"

new bool:g_KnifeRound
new g_iMaxPlayers
new g_Menu
new g_Votes[3]
new kr_teamvote
new kr_noslash

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	kr_teamvote = register_cvar("kr_teamvote", "1")   
	kr_noslash = register_cvar("kr_noslash", "1")
	
	register_clcmd("say /kf", "CmdKnifeRound", ADMIN_SLAY, "Start Knife Round")
	register_clcmd("say /kr", "CmdKnifeRound", ADMIN_SLAY, "Start Knife Round")
	register_clcmd("say /kniferound", "CmdKnifeRound", ADMIN_SLAY, "Start Knife Round")
	register_clcmd("say /rr", "CmdRestartRound", ADMIN_SLAY, "Restart Round")
	register_clcmd("say /swap", "CmdSwapTeams", ADMIN_SLAY, "Swap teams")
	
	register_clcmd("shield", "BlockCmds")
	register_clcmd("cl_rebuy", "BlockCmds")
	
	register_event("CurWeapon", "cur_weapon", "be")
	
	register_logevent("eventRoundEnd", 2, "0=World triggered", "1=Round_Draw", "1=Round_End")
	
	register_dictionary("kniferound.txt")
	
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "HamKnifePrimAttack")
	
	g_iMaxPlayers = get_maxplayers()
	
	g_Menu = menu_create("Swap teams?","menu_handle")
	build_menu()
}

public cur_weapon(id) {
    if(g_KnifeRound) engclient_cmd(id, "weapon_knife")
    return PLUGIN_CONTINUE
}

public CmdRestartRound(id, level, cid) {
    if (!cmd_access(id, level, cid, 1)) return PLUGIN_CONTINUE
    g_KnifeRound = false
    server_cmd("sv_restartround 1")
    return PLUGIN_CONTINUE
}

public CmdKnifeRound(id,level,cid) {    
    if(!cmd_access(id,level,cid,1)) return PLUGIN_CONTINUE
    server_cmd("sv_restartround 1")    
    set_task(2.0, "KnifeRoundStart", id)
    ColorChat(0, RED, "[KR] Kniferound is started!")
    ColorChat(0, RED, "[KR] Kniferound is started!") 
    ColorChat(0, RED, "[KR] Kniferound is started!")
    ColorChat(0, RED, "[KR] Kniferound is started!")
    //ColorChat(0, RED, "%L", 0, "KR_STARTED")
    //ColorChat(0, RED, "%L", 0, "KR_STARTED")
    //ColorChat(0, RED, "%L", 0, "KR_STARTED")
    //ColorChat(0, RED, "%L", 0, "KR_STARTED")
    return PLUGIN_CONTINUE
}

public CmdSwapTeams(id,level,cid) {
    if(cmd_access(id,level,cid,1)) {
        g_KnifeRound = false
        SwapTeams()
        server_cmd("sv_restartround 1")
    }
}

public KnifeRoundStart() {
    g_KnifeRound = true
    new players[32], num
    get_players(players,num)
    for(new i = 0; i < num ; i++)
    {
        new item = players[i]
        cur_weapon(item)
    }
    return PLUGIN_CONTINUE
}

public SwapTeams() {
    for(new i = 1; i <= g_iMaxPlayers; i++) {
        if(is_user_connected(i))
        {
            switch( cs_get_user_team(i))
            {
                case CS_TEAM_T: cs_set_user_team(i, CS_TEAM_CT)			
                case CS_TEAM_CT: cs_set_user_team(i,CS_TEAM_T)
            }
        }
    }
}

public eventRoundEnd() {
    if(g_KnifeRound && get_pcvar_num(kr_teamvote)) {
        new players[32], num
        get_players(players, num, "ae", "TERRORIST")
        if(!num) 
        {
        ColorChat(0, BLUE, "[KR] CT's win, they will decide to swap teams or not shortly!")
        set_task(6.0, "vote_ct")
        }
        else
        {	        
        ColorChat(0, RED, "[KR] T's win,they will decide to swap teams or not shortly!")
        set_task(6.0, "vote_t")  
        }    
    }
    g_KnifeRound = false
    return PLUGIN_CONTINUE
}

public vote_t() {
    for(new i = 1; i <= g_iMaxPlayers; i++)
    {
        if(is_user_alive(i) && cs_get_user_team(i) == CS_TEAM_T )
        {
            menu_display(i, g_Menu, 0)
        }
    }
    set_task(8.0, "finishvote")
}

public vote_ct() {
    for(new i = 1; i <= g_iMaxPlayers; i++)
    {
        if(is_user_alive(i) && cs_get_user_team(i) == CS_TEAM_CT)
        {
            menu_display(i, g_Menu, 0)
        }
    }
    set_task(8.0, "finishvote")
}

build_menu() {
    menu_additem(g_Menu, "Yes", "1")
    menu_additem(g_Menu, "No", "2")

    menu_setprop(g_Menu, MPROP_PERPAGE, 0)
}

public finishvote() {
    set_task(0.7,"func_restart",_,_,_,"a",4)
    if ( g_Votes[1] > g_Votes[2] ) 
    {
        ColorChat(0, GREEN, "[KR] The winning team decided to switch teams!")
        //ColorChat(0, GREEN, "%L", 0, "KR_SWITCH_TEAMS")
        SwapTeams()
        }
        else
        {
        ColorChat(0, BLUE, "[KR] The winning team decided to stand in!")
        //ColorChat(0, BLUE, "%L", 0, "KR_STAY_IN")
    }
}

public func_restart() {
	server_cmd("sv_restart 1")
}
 
public menu_handle(id, menu, item) {
    if( item < 0 ) return PLUGIN_CONTINUE
    new cmd[3]
    new access, callback
    menu_item_getinfo(menu, item, access, cmd,2,_,_, callback)
    new iChoice = str_to_num(cmd)
    g_Votes[iChoice]++
    return PLUGIN_HANDLED
}

public HamKnifePrimAttack(iEnt) {
    if(g_KnifeRound && get_pcvar_num(kr_noslash)) 
    {
        ExecuteHamB(Ham_Weapon_SecondaryAttack, iEnt)          
        return HAM_SUPERCEDE
    }
    return HAM_IGNORED
}

public BlockCmds(id) {
    if(g_KnifeRound) {
        return PLUGIN_HANDLED_MAIN
    }
    return PLUGIN_CONTINUE
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
